diff -uNrp a/panels/region/cinnamon-region-panel-input-chooser.ui b/panels/region/cinnamon-region-panel-input-chooser.ui
--- a/panels/region/cinnamon-region-panel-input-chooser.ui	1970-01-01 01:00:00.000000000 +0100
+++ b/panels/region/cinnamon-region-panel-input-chooser.ui	2013-09-21 13:24:15.339949536 +0100
@@ -0,0 +1,157 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<interface>
+  <requires lib="gtk+" version="2.16"/>
+  <object class="GtkListStore" id="input_source_model">
+    <columns>
+      <!-- display name -->
+      <column type="gchararray"/>
+      <!-- input source type -->
+      <column type="gchararray"/>
+      <!-- type specific identifier -->
+      <column type="gchararray"/>
+    </columns>
+  </object>
+  <object class="GtkTreeModelFilter" id="filtered_input_source_model">
+    <property name="child_model">input_source_model</property>
+  </object>
+  <object class="GtkDialog" id="input_source_chooser">
+    <property name="visible">False</property>
+    <property name="can_focus">False</property>
+    <property name="border_width">5</property>
+    <property name="title" translatable="yes">Choose an input source</property>
+    <property name="modal">True</property>
+    <property name="window_position">center-on-parent</property>
+    <property name="type_hint">dialog</property>
+    <child internal-child="vbox">
+      <object class="GtkBox" id="dialog-vbox3">
+        <property name="visible">True</property>
+        <property name="can_focus">False</property>
+        <property name="orientation">vertical</property>
+        <property name="spacing">2</property>
+        <child internal-child="action_area">
+          <object class="GtkButtonBox" id="hbtnBox">
+            <property name="visible">True</property>
+            <property name="can_focus">False</property>
+            <property name="layout_style">end</property>
+            <child>
+              <object class="GtkButton" id="cancel-button">
+                <property name="label">gtk-cancel</property>
+                <property name="visible">True</property>
+                <property name="can_focus">True</property>
+                <property name="can_default">True</property>
+                <property name="receives_default">False</property>
+                <property name="use_action_appearance">False</property>
+                <property name="use_stock">True</property>
+              </object>
+              <packing>
+                <property name="expand">False</property>
+                <property name="fill">False</property>
+                <property name="pack_type">end</property>
+                <property name="position">1</property>
+              </packing>
+            </child>
+            <child>
+              <object class="GtkButton" id="ok-button">
+                <property name="label">gtk-add</property>
+                <property name="visible">True</property>
+                <property name="can_focus">True</property>
+                <property name="can_default">True</property>
+                <property name="receives_default">False</property>
+                <property name="use_action_appearance">False</property>
+                <property name="use_stock">True</property>
+              </object>
+              <packing>
+                <property name="expand">False</property>
+                <property name="fill">False</property>
+                <property name="pack_type">end</property>
+                <property name="position">2</property>
+              </packing>
+            </child>
+          </object>
+        </child>
+        <child>
+          <object class="GtkVBox" id="vbox40">
+            <property name="visible">True</property>
+            <property name="can_focus">False</property>
+            <property name="border_width">5</property>
+            <property name="spacing">6</property>
+            <child>
+              <object class="GtkVBox" id="vbox1">
+                <property name="visible">True</property>
+                <property name="can_focus">False</property>
+                <property name="spacing">6</property>
+                <child>
+                  <object class="GtkLabel" id="label1">
+                    <property name="visible">True</property>
+                    <property name="can_focus">False</property>
+                    <property name="xalign">0</property>
+                    <property name="label" translatable="yes">Select an input source to add</property>
+                  </object>
+                  <packing>
+                    <property name="expand">False</property>
+                    <property name="fill">False</property>
+                    <property name="position">0</property>
+                  </packing>
+                </child>
+                <child>
+                  <object class="GtkScrolledWindow" id="scrolledwindow1">
+                    <property name="visible">True</property>
+                    <property name="can_focus">True</property>
+                    <property name="hscrollbar_policy">never</property>
+                    <property name="shadow_type">etched-in</property>
+                    <property name="min_content_width">450</property>
+                    <property name="min_content_height">250</property>
+                    <child>
+                      <object class="GtkTreeView" id="filtered_input_source_list">
+                        <property name="visible">True</property>
+                        <property name="can_focus">True</property>
+                        <property name="model">filtered_input_source_model</property>
+                        <property name="headers_visible">False</property>
+                        <property name="search_column">0</property>
+                      </object>
+                    </child>
+                  </object>
+                  <packing>
+                    <property name="expand">True</property>
+                    <property name="fill">True</property>
+                    <property name="position">1</property>
+                  </packing>
+                </child>
+              </object>
+              <packing>
+                <property name="expand">True</property>
+                <property name="fill">True</property>
+                <property name="position">0</property>
+              </packing>
+            </child>
+            <child>
+              <object class="GtkEntry" id="input_source_filter">
+                <property name="visible">True</property>
+                <property name="can_focus">True</property>
+                <property name="invisible_char">•</property>
+                <property name="secondary-icon-name">edit-find-symbolic</property>
+                <property name="secondary-icon-activatable">False</property>
+                <property name="secondary-icon-sensitive">False</property>
+              </object>
+              <packing>
+                <property name="expand">False</property>
+                <property name="fill">False</property>
+                <property name="pack_type">end</property>
+                <property name="position">1</property>
+              </packing>
+            </child>
+          </object>
+          <packing>
+            <property name="expand">True</property>
+            <property name="fill">True</property>
+            <property name="position">1</property>
+          </packing>
+        </child>
+      </object>
+    </child>
+    <action-widgets>
+      <action-widget response="-5">ok-button</action-widget>
+      <action-widget response="-6">cancel-button</action-widget>
+    </action-widgets>
+  </object>
+</interface>
diff -uNrp a/panels/region/cinnamon-region-panel-input.h b/panels/region/cinnamon-region-panel-input.h
--- a/panels/region/cinnamon-region-panel-input.h	1970-01-01 01:00:00.000000000 +0100
+++ b/panels/region/cinnamon-region-panel-input.h	2013-09-21 13:24:15.339949536 +0100
@@ -0,0 +1,36 @@
+/* cinnamon-region-panel-input.h
+ * Copyright (C) 2011 Red Hat, Inc.
+ *
+ * Written by Matthias Clasen
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2, or (at your option)
+ * any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street - Suite 500, Boston, MA
+ * 02110-1335, USA.
+ */
+
+#ifndef __CINNAMON_KEYBOARD_PROPERTY_INPUT_H
+#define __CINNAMON_KEYBOARD_PROPERTY_INPUT_H
+
+#include <gtk/gtk.h>
+
+#include "cc-region-panel.h"
+
+G_BEGIN_DECLS
+
+void setup_input_tabs (GtkBuilder    *builder,
+                       CcRegionPanel *self);
+
+G_END_DECLS
+
+#endif  /* __CINNAMON_KEYBOARD_PROPERTY_INPUT_H */
diff -uNrp a/panels/region/cinnamon-region-panel-lang.c b/panels/region/cinnamon-region-panel-lang.c
--- a/panels/region/cinnamon-region-panel-lang.c	2013-08-25 14:40:14.000000000 +0100
+++ b/panels/region/cinnamon-region-panel-lang.c	2013-09-21 13:24:15.340949500 +0100
@@ -24,7 +24,7 @@
 #endif
 
 #include <string.h>
-#include <glib/gi18n-lib.h>
+#include <glib/gi18n.h>
 
 #include "cinnamon-region-panel-lang.h"
 #include "cinnamon-region-panel-formats.h"
diff -uNrp a/panels/region/cinnamon-region-panel-lang.h b/panels/region/cinnamon-region-panel-lang.h
--- a/panels/region/cinnamon-region-panel-lang.h	2013-08-25 14:40:14.000000000 +0100
+++ b/panels/region/cinnamon-region-panel-lang.h	2013-09-21 13:24:15.340949500 +0100
@@ -19,8 +19,8 @@
  * 02110-1335, USA.
  */
 
-#ifndef __GNOME_KEYBOARD_PROPERTY_LANG_H
-#define __GNOME_KEYBOARD_PROPERTY_LANG_H
+#ifndef __CINNAMON_KEYBOARD_PROPERTY_LANG_H
+#define __CINNAMON_KEYBOARD_PROPERTY_LANG_H
 
 #include <gtk/gtk.h>
 
@@ -29,4 +29,4 @@ G_BEGIN_DECLS
 void setup_language (GtkBuilder *builder);
 
 G_END_DECLS
-#endif /* __GNOME_KEYBOARD_PROPERTY_LANG_H */
+#endif /* __CINNAMON_KEYBOARD_PROPERTY_LANG_H */
diff -uNrp a/panels/region/cinnamon-region-panel-system.c b/panels/region/cinnamon-region-panel-system.c
--- a/panels/region/cinnamon-region-panel-system.c	2013-08-25 14:40:14.000000000 +0100
+++ b/panels/region/cinnamon-region-panel-system.c	2013-09-21 13:24:15.342949428 +0100
@@ -27,15 +27,18 @@
 
 #include <polkit/polkit.h>
 
-#include <glib/gi18n-lib.h>
+#include <glib/gi18n.h>
+
+#define GNOME_DESKTOP_USE_UNSTABLE_API
+#include <libcinnamon-desktop/gnome-xkb-info.h>
 
-#include <libgnomekbd/gkbd-keyboard-config.h>
 #include "cc-common-language.h"
 #include "gdm-languages.h"
 #include "cinnamon-region-panel-system.h"
-#include "cinnamon-region-panel-xkb.h"
 
-static GSettings *locale_settings, *xkb_settings;
+#define WID(s) GTK_WIDGET(gtk_builder_get_object (dialog, s))
+
+static GSettings *locale_settings, *input_sources_settings;
 static GDBusProxy *localed_proxy;
 static GPermission *localed_permission;
 
@@ -72,13 +75,14 @@ update_copy_button (GtkBuilder *dialog)
 
         button = WID ("copy_settings_button");
 
-        /* If the version of localed doesn't include layouts... */
-        if (system_input_source) {
+        if (user_input_source && user_input_source[0]) {
                 layouts_differ = (g_strcmp0 (user_input_source, system_input_source) != 0);
                 if (layouts_differ == FALSE)
                         layouts_differ = (g_strcmp0 (user_input_variants, system_input_variants) != 0);
-        } else
+        } else {
+                /* Nothing to copy */
                 layouts_differ = FALSE;
+        }
 
         if (g_strcmp0 (user_lang, system_lang) == 0 &&
             g_strcmp0 (user_region, system_region) == 0 &&
@@ -131,61 +135,67 @@ system_update_language (GtkBuilder *dial
 }
 
 static void
-xkb_settings_changed (GSettings *settings,
-                      const gchar *key,
-                      GtkBuilder *dialog)
+input_sources_changed (GSettings *settings,
+                       const gchar *key,
+                       GtkBuilder *dialog)
 {
-	guint i;
-	GString *disp, *list, *variants;
-	GtkWidget *label;
-	gchar **layouts;
-
-	layouts = g_settings_get_strv (settings, "layouts");
-	if (layouts == NULL)
-		return;
-
-	label = WID ("user_input_source");
-	disp = g_string_new ("");
-	list = g_string_new ("");
-	variants = g_string_new ("");
-
-	for (i = 0; layouts[i]; i++) {
-		gchar *utf_visible;
-		char **split;
-		gchar *layout, *variant;
-
-		utf_visible = xkb_layout_description_utf8 (layouts[i]);
-		if (disp->str[0] != '\0')
-			g_string_append (disp, ", ");
-		g_string_append (disp, utf_visible ? utf_visible : layouts[i]);
-		g_free (utf_visible);
-
-		split = g_strsplit_set (layouts[i], " \t", 2);
-
-		if (split == NULL || split[0] == NULL)
-			continue;
-
-		layout = split[0];
-		variant = split[1];
-
-		if (list->str[0] != '\0')
-			g_string_append (list, ",");
-		g_string_append (list, layout);
-
-		if (variants->str[0] != '\0')
-			g_string_append (variants, ",");
-		g_string_append (variants, variant ? variant : "");
-
-		g_strfreev (split);
-	}
-	g_strfreev (layouts);
+        GString *disp, *list, *variants;
+        GtkWidget *label;
+        GnomeXkbInfo *xkb_info;
+        GVariantIter iter;
+        GVariant *sources;
+        const gchar *type;
+        const gchar *id;
+
+        sources = g_settings_get_value (input_sources_settings, "sources");
+        xkb_info = gnome_xkb_info_new ();
+
+        label = WID ("user_input_source");
+        disp = g_string_new ("");
+        list = g_string_new ("");
+        variants = g_string_new ("");
+
+        g_variant_iter_init (&iter, sources);
+        while (g_variant_iter_next (&iter, "(&s&s)", &type, &id)) {
+                /* We can't copy non-XKB layouts to the system yet */
+                if (g_str_equal (type, "xkb")) {
+                        char **split;
+                        gchar *layout, *variant;
+                        const char *name;
+
+                        gnome_xkb_info_get_layout_info (xkb_info, id, &name, NULL, NULL, NULL);
+                        if (disp->str[0] != '\0')
+                                g_string_append (disp, ", ");
+                        g_string_append (disp, name);
+
+                        split = g_strsplit (id, "+", 2);
+
+                        if (split == NULL || split[0] == NULL)
+                                continue;
+
+                        layout = split[0];
+                        variant = split[1];
+
+                        if (list->str[0] != '\0') {
+                                g_string_append (list, ",");
+                                g_string_append (variants, ",");
+                        }
+                        g_string_append (list, layout);
+                        g_string_append (variants, variant ? variant : "");
+
+                        g_strfreev (split);
+                }
+        }
+        g_variant_unref (sources);
+        g_object_unref (xkb_info);
 
         g_object_set_data_full (G_OBJECT (label), "input_source", g_string_free (list, FALSE), g_free);
         g_object_set_data_full (G_OBJECT (label), "input_variants", g_string_free (variants, FALSE), g_free);
+
         gtk_label_set_text (GTK_LABEL (label), disp->str);
         g_string_free (disp, TRUE);
 
-	update_copy_button (dialog);
+        update_copy_button (dialog);
 }
 
 static void
@@ -222,12 +232,13 @@ on_localed_properties_changed (GDBusProx
                                const gchar **invalidated_properties,
                                GtkBuilder   *dialog)
 {
-        GVariant *v;
+        GVariant *v, *w;
         GtkWidget *label;
-        const char *layout;
+        GnomeXkbInfo *xkb_info;
         char **layouts;
+        char **variants;
         GString *disp;
-        guint i;
+        guint i, n;
 
         if (invalidated_properties != NULL) {
                 guint i;
@@ -236,6 +247,8 @@ on_localed_properties_changed (GDBusProx
                                 update_property (proxy, "Locale");
                         else if (g_str_equal (invalidated_properties[i], "X11Layout"))
                                 update_property (proxy, "X11Layout");
+                        else if (g_str_equal (invalidated_properties[i], "X11Variant"))
+                                update_property (proxy, "X11Variant");
                 }
         }
 
@@ -290,29 +303,56 @@ on_localed_properties_changed (GDBusProx
         label = WID ("system_input_source");
         v = g_dbus_proxy_get_cached_property (proxy, "X11Layout");
         if (v) {
-                layout = g_variant_get_string (v, NULL);
-                g_object_set_data_full (G_OBJECT (label), "input_source", g_strdup (layout), g_free);
-	} else {
+                layouts = g_strsplit (g_variant_get_string (v, NULL), ",", -1);
+                g_object_set_data_full (G_OBJECT (label), "input_source",
+                                        g_variant_dup_string (v, NULL), g_free);
+                g_variant_unref (v);
+        } else {
                 g_object_set_data_full (G_OBJECT (label), "input_source", NULL, g_free);
                 update_copy_button (dialog);
                 return;
         }
 
-	disp = g_string_new ("");
-	layouts = g_strsplit (layout, ",", -1);
-	for (i = 0; layouts[i]; i++) {
-		gchar *utf_visible;
-
-		utf_visible = xkb_layout_description_utf8 (layouts[i]);
-		if (disp->str[0] != '\0')
-			disp = g_string_append (disp, ", ");
-		disp = g_string_append (disp, utf_visible ? utf_visible : layouts[i]);
-		g_free (utf_visible);
-	}
+        w = g_dbus_proxy_get_cached_property (proxy, "X11Variant");
+        if (w) {
+                variants = g_strsplit (g_variant_get_string (w, NULL), ",", -1);
+                g_object_set_data_full (G_OBJECT (label), "input_variants",
+                                        g_variant_dup_string (w, NULL), g_free);
+                g_variant_unref (w);
+        } else {
+                variants = NULL;
+                g_object_set_data_full (G_OBJECT (label), "input_variants", NULL, g_free);
+        }
+
+        if (variants && variants[0])
+                n = MIN (g_strv_length (layouts), g_strv_length (variants));
+        else
+                n = g_strv_length (layouts);
+
+        xkb_info = gnome_xkb_info_new ();
+        disp = g_string_new ("");
+        for (i = 0; i < n && layouts[i][0]; i++) {
+                const char *name;
+                char *id;
+
+                if (variants && variants[i] && variants[i][0])
+                        id = g_strdup_printf ("%s+%s", layouts[i], variants[i]);
+                else
+                        id = g_strdup (layouts[i]);
+
+                gnome_xkb_info_get_layout_info (xkb_info, id, &name, NULL, NULL, NULL);
+                if (disp->str[0] != '\0')
+                        disp = g_string_append (disp, ", ");
+                disp = g_string_append (disp, name ? name : id);
+
+                g_free (id);
+        }
         gtk_label_set_text (GTK_LABEL (label), disp->str);
         g_string_free (disp, TRUE);
 
-        g_variant_unref (v);
+        g_strfreev (variants);
+        g_strfreev (layouts);
+        g_object_unref (xkb_info);
 
         update_copy_button (dialog);
 }
@@ -386,6 +426,11 @@ copy_settings (GtkButton *button, GtkBui
         layout = g_object_get_data (G_OBJECT (label), "input_source");
         variants = g_object_get_data (G_OBJECT (label), "input_variants");
 
+        if (layout == NULL || layout[0] == '\0') {
+                g_debug ("Not calling SetX11Keyboard, as there are no XKB input sources in the user's settings");
+                return;
+        }
+
         g_dbus_proxy_call (localed_proxy,
                            "SetX11Keyboard",
                            g_variant_new ("(ssssbb)", layout, "", variants ? variants : "", "", TRUE, TRUE),
@@ -468,10 +513,10 @@ setup_system (GtkBuilder *dialog)
                           G_CALLBACK (locale_settings_changed), dialog);
         g_object_weak_ref (G_OBJECT (dialog), (GWeakNotify) g_object_unref, locale_settings);
 
-	xkb_settings = g_settings_new (GKBD_KEYBOARD_SCHEMA);
-	g_signal_connect (xkb_settings, "changed::layouts",
-			  G_CALLBACK (xkb_settings_changed), dialog);
-	g_object_weak_ref (G_OBJECT (dialog), (GWeakNotify) g_object_unref, xkb_settings);
+        input_sources_settings = g_settings_new ("org.cinnamon.desktop.input-sources");
+        g_signal_connect (input_sources_settings, "changed::sources",
+                          G_CALLBACK (input_sources_changed), dialog);
+        g_object_weak_ref (G_OBJECT (dialog), (GWeakNotify) g_object_unref, input_sources_settings);
 
         /* Display user settings */
         language = cc_common_language_get_current_language ();
@@ -480,7 +525,7 @@ setup_system (GtkBuilder *dialog)
 
         locale_settings_changed (locale_settings, "region", dialog);
 
-        xkb_settings_changed (xkb_settings, "layouts", dialog);
+        input_sources_changed (input_sources_settings, "sources", dialog);
 
         bus = g_bus_get_sync (G_BUS_TYPE_SYSTEM, NULL, NULL);
         g_dbus_proxy_new (bus,
diff -uNrp a/panels/region/cinnamon-region-panel-system.h b/panels/region/cinnamon-region-panel-system.h
--- a/panels/region/cinnamon-region-panel-system.h	2013-08-25 14:40:14.000000000 +0100
+++ b/panels/region/cinnamon-region-panel-system.h	2013-09-21 13:24:15.342949428 +0100
@@ -19,8 +19,8 @@
  * 02110-1335, USA.
  */
 
-#ifndef __GNOME_REGION_PANEL_SYSTEM_H
-#define __GNOME_REGION_PANEL_SYSTEM_H
+#ifndef __CINNAMON_REGION_PANEL_SYSTEM_H
+#define __CINNAMON_REGION_PANEL_SYSTEM_H
 
 #include <gtk/gtk.h>
 
